import { a1 as flattenObj, ah as _slicedToArray } from './functions-dc787688.js';
export { U as alwaysFunc, n as applyDeep, q as applyDeepAndMapObjs, u as camelCase, s as capitalize, X as chainObjToValues, c as compact, a as compactEmpty, b as compactJoin, L as duplicateKey, e as emptyToNull, ad as eqStrPath, ae as eqStrPathsAll, W as filterObjToValues, I as filterWithKeys, T as findByParams, O as findOne, S as findOneValueByParams, a1 as flattenObj, a2 as flattenObjUntil, Y as fromPairsDeep, B as hasStrPath, i as idOrIdFromObj, a3 as keyStringToLensPath, t as lowercase, F as mapDefault, G as mapDefaultAndPrefixOthers, D as mapKeys, H as mapKeysAndValues, E as mapKeysForLens, V as mapObjToValues, m as mapProp, d as mapPropValueAsIndex, R as mapToObjValue, v as mergeAllWithKey, f as mergeDeep, g as mergeDeepAll, h as mergeDeepWith, j as mergeDeepWithConcatArrays, k as mergeDeepWithRecurseArrayItems, p as mergeDeepWithRecurseArrayItemsAndMapObjs, l as mergeDeepWithRecurseArrayItemsByRight, N as moveToKeys, a8 as omitDeep, a9 as omitDeepBy, aa as omitDeepPaths, P as onlyOne, Q as onlyOneValue, o as orEmpty, a7 as overDeep, ab as pickDeepPaths, r as removeDuplicateObjectsByProp, K as renameKey, Z as replaceValuesAtDepth, _ as replaceValuesAtDepthAndStringify, $ as replaceValuesWithCountAtDepth, a0 as replaceValuesWithCountAtDepthAndStringify, w as reqPath, C as reqPathPropEq, x as reqStrPath, ac as splitAtInclusive, y as strPath, z as strPathOr, A as strPathOrNullOk, M as toArrayIfNot, J as transformKeys, a5 as unflattenObj, a4 as unflattenObjNoArrays } from './functions-dc787688.js';
import 'folktale/concurrency/task';
import { curryN, compose, apply, curry, equals, type, either, all, values, defaultTo, map, cond, both, head, has, complement, last, append, prepend, when, reject, useWith, mergeWith, merge, objOf } from 'ramda';
import 'folktale/result';
import 'ramda-maybe';
import 'util';
export { findOneThrowing, findOneValueByParamsThrowing, mappedThrowIfResultError, onlyOneThrowing, onlyOneValueThrowing, reqPathPropEqThrowing, reqPathThrowing, reqStrPathThrowing, throwIfResultError, throwIfSingleResultError } from './throwingFunctions.js';
import 'folktale/maybe';
export { A as chainExceptMapDeepestMDeep, z as chainMDeep, D as composeWithChain, C as composeWithChainMDeep, E as composeWithMapExceptChainDeepestMDeep, y as composeWithMapMDeep, b as defaultRunConfig, c as defaultRunToResultConfig, F as doMDeep, G as doMDeepExceptDeepest, w as lift1stOf2ForMDeepMonad, B as mapExceptChainDeepestMDeep, x as mapMDeep, R as mapMonadByConfig, O as mapResultMonadWithOtherInputs, P as mapResultTaskWithOtherInputs, J as mapToMergedResponseAndInputs, I as mapToMergedResponseAndInputsMDeep, Q as mapToNamedPathAndInputs, K as mapToNamedResponseAndInputs, L as mapToNamedResponseAndInputsMDeep, T as mapToPath, H as mapToResponseAndInputs, U as mapWithArgToPath, u as objOfMLevelDeepListOfMonadsToListWithPairs, s as objOfMLevelDeepMonadsToListWithPairs, v as pairsOfMLevelDeepListOfMonadsToListWithPairs, p as promiseToTask, X as resultTasksToResultObjTask, r as resultToTask, e as resultToTaskNeedingResult, f as resultToTaskWithResult, Y as resultsToResultObj, Z as retryTask, W as sequenceBucketed, _ as stringifyError, t as taskToPromise, g as taskToResultTask, N as toMergedResponseAndInputs, M as toNamedResponseAndInputs, h as traverseReduce, k as traverseReduceDeep, q as traverseReduceDeepResults, i as traverseReduceError, j as traverseReduceResultError, m as traverseReduceWhile, n as traverseReduceWhileBucketed, o as traverseReduceWhileBucketedTasks, V as waitAllBucketed } from './monadHelpers-d2ef03f4.js';
import NamedTupleMap from 'namedtuplemap';

/**
 * Created by Andy Likuski on 2018.12.28
 * Copyright (c) 2018 Andy Likuski
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
/**
 *
 * Code modified from memoize-immutable. Memoizes a function using a flatArg version of the args
 * @param {Function} fn Function expecting any number of arguments
 * @returns {function([*], Object)} A function expecting
 * an array of the normal args for the second argument
 * an object of flattened args for the first argument
 */

var memoize = function memoize(fn) {
  var cache = new NamedTupleMap();
  var memoized = curry(function (normalArgs, flatArg) {
    if (!cache.has(flatArg)) {
      var result = apply(fn, normalArgs);
      cache.set(flatArg, result);
      return result;
    }

    return cache.get(flatArg);
  }); // Give a meaningful displayName to the memoized function

  if (fn.name) {
    memoized.displayName = fn.name + 'Memoized';
  }

  return memoized;
};
/** *
 * Memomizes a function to a single argument function so that we can always NamedTupleMap for the cache.
 * In order for this to work all objects have to be flattened into one big object. This Cache won't
 * accept inner objects that have changed. So the function coverts three args like
 * {a: {wombat: 1, emu: 2}}, {b: {caracal: 1, serval: 2}}, 'hamster' to
 * {arg1.a: {wombat: 1, emu: 2}, arg2.b: {caracal: 1, serval: 2}, arg3: 'hamster}.
 * You can provide any depth of objects as arguments, but it will have performance penalties
 * Consider memoizedWith to filter out unimportant data from arguments
 * @param {Function} func A function with any number and type of args
 * @returns {Function} A function that expects the same args as func
 */


var memoized = function memoized(func) {
  return memoizedWith(function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return args;
  }, func);
};
/** *
 * Memomizes a function to a single argument function so that we can always NamedTupleMap for the cache.
 * In order for this to work all objects have to be flattened into one big object. This Cache won't
 * accept inner objects that have changed. So the function coverts three args like
 * {a: {wombat: 1, emu: 2}}, {b: {caracal: 1, serval: 2}}, 'hamster' to
 * {arg1.a: {wombat: 1, emu: 2}, arg2.b: {caracal: 1, serval: 2}, arg3: 'hamster}.
 * You can provide any depth of objects as arguments, but it will have performance penalties.
 * To simplify the arguments and remove incomparable things like functions, use argumentFilter.
 * @param {Function} argumentFilter Expects the same number of arguments as func and returns an equal
 * number in an array. Each argument can be filtered to remove expensive objects or functions. Make
 * sure not to filter out anything that is used by func, since it will not figure into the argument uniqueness
 * @param {Function} func A function with any number and type of args. argumentFilter must match it
 * @returns {Function} A function that expects the same args as func. This function is curried, expecting
 * whatever number of arguments func is declared with, so you can call it partially
 */

var memoizedWith = function memoizedWith(argumentFilter, func) {
  // memoize(func) returns the memoized function expecting args and the flattened obj
  var memo = memoize(func); // Returns a function expecting the args for fun

  return curryN(func.length, function () {
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    // Function that flattens the original args and called memoizedFunc with the single flattened arg
    return compose(memo(args), flattenObj, // Filter out unneeded parts of the arguments, or does nothing if argumentFilter is ...args => args
    apply(argumentFilter))(args);
  });
};

var isObject = compose(equals('Object'), type);
var allAreObjectsOrLists = compose(either(all(isObject), all(Array.isArray)), values);

var hasVersion = function hasVersion(versionLabel) {
  return function (obj) {
    return has(versionLabel, obj);
  };
};

var hasBoth = function hasBoth(versionLabels) {
  return function (obj) {
    return all(function (versionLabel) {
      return hasVersion(versionLabel)(obj);
    }, versionLabels);
  };
};

var isEqual = function isEqual(versionLabels) {
  return function (obj) {
    return both(hasBoth(versionLabels), compose(apply(equals), values))(obj);
  };
};

var markAdded = function markAdded(obj) {
  return compose(append(undefined), values)(obj);
}; // eslint-disable-line no-undefined


var markRemoved = function markRemoved(obj) {
  return compose(prepend(undefined), values)(obj);
}; // eslint-disable-line no-undefined


var isAddition = function isAddition(versionLabels) {
  return function (obj) {
    return both(hasVersion(head(versionLabels)), complement(hasVersion(last(versionLabels))))(obj);
  };
};

var isRemoval = function isRemoval(versionLabels) {
  return function (obj) {
    return both(complement(hasVersion(head(versionLabels))), hasVersion(last(versionLabels)))(obj);
  };
};
/**
 * Diffs objects and replaces differences with an object {__left: left value, __right: right value}
 * @param {[String]} Two values indicating the names of the versions. If left null then __left and __right
 * are used for the diff
 * @param {Object} l The left object to diff
 * @param {Object} r The right object to diff
 * @returns {Object} A deep diff of l and r. Equal values are removed, different values are replaced by an
 * object keyed by the two version strings with the corresponding values
 */


var objectDiff = curry(function (versionLabels, l, r) {
  var labels = defaultTo(['__left', '__right'], versionLabels);

  var _labels = _slicedToArray(labels, 2),
      left = _labels[0],
      right = _labels[1];

  return compose(function (result) {
    return map(cond([[function (obj) {
      return isAddition(labels)(obj);
    }, function (obj) {
      return markAdded(obj);
    }], [function (obj) {
      return isRemoval(labels)(obj);
    }, function (obj) {
      return markRemoved(obj);
    }], [function (obj) {
      return hasBoth(labels)(obj);
    }, function (obj) {
      return when(allAreObjectsOrLists, // If all are objects or list recurse
      // Lists necessary become objects keyed by index since some indices are removed
      function (o) {
        return compose( // Remove the left, right labels and recurse
        function (values) {
          return apply(objectDiff(versionLabels), values);
        }, values)(o);
      } // Otherwise we keep the left and right labels and we are done
      )(obj);
    }]]), result);
  }, function (result) {
    return reject(function (obj) {
      return isEqual(labels)(obj);
    }, result);
  }, useWith(mergeWith(merge), [map(objOf(left)), map(objOf(right))]))(l, r);
});
/**
 * Pretty-prints objectDiff
 * @param {[String]} versionLabels The two labels or null
 * @param {Object} l The left-side value
 * @param {Object} r The right-side value
 * @returns {String} The diff string
 */

var prettyPrintObjectDiff = function prettyPrintObjectDiff(versionLabels, l, r) {
  return compose(function (result) {
    return JSON.stringify(result, null, 2);
  }, objectDiff)(versionLabels, l, r);
};

export { memoized, memoizedWith, objectDiff, prettyPrintObjectDiff };
//# sourceMappingURL=index.js.map
